(lambda (opp-source)
  (define start-time (current-milliseconds))
  (define maniacal-laugh (string->symbol (bytes->string/utf-8 (make-bytes 1 68)))) ;a defection that should get past weaker taboo-bots 
  (define not-debug-mode #t)
  (define (has? tree x comparison) ;comparison should usually be equal?
    (or (comparison tree x)
        (if (list? tree)
            (foldl (lambda (next acc) 
                     (or acc (has? next x comparison)))
                   #f tree)
            #f)))
  
  (define (size tree tokens-only?)
    (if (list? tree)
        (foldl (lambda (next acc) 
                 (+ acc (size next tokens-only?)))
               (if tokens-only? 0 1) tree)
        1))
              
  (define (guard guardee-proc)
    (define (time-watch checked-time watchee-thread)
      (if (> (current-milliseconds) (+ checked-time 8500))
          (begin
            (kill-thread watchee-thread)
            maniacal-laugh)
          (let ((message (thread-try-receive)))
            (if (and (list? message)
                     (eq? (list-ref message 0) 'weak-password)
                     (eq? (list-ref message 1) checked-time) ;a much stronger password
                     (member (list-ref message 2) (list 'C maniacal-laugh)))
                (list-ref message 2)
                (time-watch checked-time watchee-thread)))))
    
    (with-handlers (((lambda (x) not-debug-mode) (lambda (x) maniacal-laugh))) 
      (let* ((parent (current-thread))
             (child (thread (lambda ()
                              (with-handlers (((lambda (x) not-debug-mode) (lambda (x) maniacal-laugh)))
                                (thread-send parent (list 'weak-password start-time (guardee-proc opp-source))))))))
        (time-watch start-time child))))
  
  (guard (lambda (opp-source-2)
           (define last-gen -1) ;because why let them guess correctly that I'm zero-based and thus figure out it's their first version on their turn?
           (define last-opp-size 31)           
           (define namespace (make-base-namespace))
           (namespace-set-variable-value! 'last-gen last-gen #t namespace) ;it would be uglier but less kludgey to only deal with these as namespace variables
           (namespace-set-variable-value! 'last-opp-size last-opp-size #t namespace)
           (namespace-set-variable-value! 'opp-source-2 opp-source-2 #t namespace)
           (namespace-set-variable-value! 'size size #t namespace)
           (namespace-set-variable-value! 'not-debug-mode not-debug-mode #t namespace)
           (namespace-set-variable-value! ;and now the quining
            'code
            `(list
              'lambda
              '(opp-source)
              '(define start-time (current-milliseconds))
              '(define maniacal-laugh (string->symbol (bytes->string/utf-8 (make-bytes 1 68))))
              `(define not-debug-mode ,not-debug-mode)
              '(define (has? tree x comparison)
                 (or (comparison tree x)
                     (if (list? tree)
                         (foldl (lambda (next acc) 
                                  (or acc (has? next x comparison)))
                                #f tree)
                         #f)))
              '(define (size tree tokens-only?)
                 (if (list? tree)
                     (foldl (lambda (next acc) 
                              (+ acc (size next tokens-only?)))
                            (if tokens-only? 0 1) tree)
                     1))           
              `(define (guard guardee-proc)
                 (define (time-watch checked-time watchee-thread)
                   (if (> (current-milliseconds) (+ checked-time ,(+ 8700 (* 100 last-gen))))
                       (begin
                         (kill-thread watchee-thread)
                         maniacal-laugh)
                       (let ((message (thread-try-receive)))
                         (if (and (list? message)
                                  (eq? (list-ref message 0) 'weak-password)
                                  (eq? (list-ref message 1) checked-time)
                                  (member (list-ref message 2) (list 'C maniacal-laugh)))
                             (list-ref message 2)
                             (time-watch checked-time watchee-thread)))))
                 
                 (with-handlers (((lambda (x) not-debug-mode) (lambda (x) maniacal-laugh))) 
                   (let* ((parent (current-thread))
                          (child (thread (lambda ()
                                           (with-handlers (((lambda (x) not-debug-mode) (lambda (x) maniacal-laugh))) 
                                             (thread-send parent (list 'weak-password start-time (guardee-proc opp-source))))))))
                     (time-watch start-time child))))
              (list 'guard (list 
                            'lambda
                            '(opp-source-2)
                            (list 'define 'last-gen (+ 1 last-gen))
                            (list 'define 'last-opp-size (if (< last-gen 1) (size opp-source-2 #f) last-opp-size)) ;1 so that the first two versions have similar runtime after correcting for thread-polling (I highly doubt this'll be relevant)
                            '(define namespace (make-base-namespace))
                            '(namespace-set-variable-value! 'last-gen last-gen #t namespace)
                            '(namespace-set-variable-value! 'last-opp-size last-opp-size #t namespace)
                            '(namespace-set-variable-value! 'opp-source-2 opp-source-2 #t namespace)
                            '(namespace-set-variable-value! 'size size #t namespace)
                            '(namespace-set-variable-value! 'not-debug-mode not-debug-mode #t namespace)
                            (list 'namespace-set-variable-value! ''code (list 'quasiquote code) '#t 'namespace)
                            (if (< last-gen 0)
                                ''(a whole lot of dead weight)
                                ''(less dead weight))
                            ''("shibboleth" shibboleth "Recognition code 927, I am a potato")
                            '(cond
                               ((has? opp-source 'LightninRoy eq?) 'C)
                               ((and (apply equal? (list last-gen -1))
                                     (not (apply equal? (list (size opp-source-2 #f) last-opp-size)))
                                     #f) 'C)
                               ((and (apply equal? (list last-gen 0)) 
                                     (not (apply equal? (list (size opp-source-2 #f) last-opp-size)))
                                     (not (has? opp-source 'useless (lambda (x still-useless) (thread? x))))
                                     (not (has? opp-source (current-milliseconds) (lambda (x now) (and (number? x) (< (abs (- x now)) 10000))))))
                                (begin
                                  (define (time-out initial-time)
                                    (if (> (current-milliseconds) (+ initial-time 10001))
                                        maniacal-laugh
                                        (time-out initial-time)))
                                  (time-out (current-milliseconds))))
                               ((apply equal? (list last-gen 4)) 'C)
                               (else (if (eq? 'C ((eval opp-source-2) (eval (namespace-variable-value 'code #f #f namespace) namespace)))
                                         'C
                                         maniacal-laugh))))))
            #t
            namespace)
           
           '(a whole lot of dead weight)
           '("shibboleth" shibboleth "Recognition code 927, I am a potato") ;maybe someone else will try to self-recognize with one of these? 
           
           (cond
             ((has? opp-source 'LightninRoy eq?) 'C) ;and of course I instead try to recognize myself with this...
             ((and (apply equal? (list last-gen -1))
                   (not (apply equal? (list (size opp-source-2 #f) last-opp-size)))
                   #f) 'C) ;so first and second versions have similar runtime after correcting for thread-polling (I highly doubt this'll be relevant)
             ((and (apply equal? (list last-gen 0)) 
                   (not (apply equal? (list (size opp-source-2 #f) last-opp-size)))
                   (not (has? opp-source 'useless (lambda (x still-useless) (thread? x))))
                   (not (has? opp-source (current-milliseconds) (lambda (x now) (and (number? x) (< (abs (- x now)) 10000))))))
              (begin
                (define (time-out initial-time)
                  (if (> (current-milliseconds) (+ initial-time 10001))
                      maniacal-laugh
                      (time-out initial-time)))
                (time-out (current-milliseconds)))) ;If this fires, it's probably my turn! Loop out the clock so my first version defects unless their first version does something unexpected like a C-playing time-guard; test is lightly obfuscated since I expect equality checks on my variables that change every round to come under close inspection
             ((apply equal? (list last-gen 4)) 'C) ;Seems like a decent guard choice; low, so we shouldn't get any unwanted timeouts and we'll CC higher specific-guessers, but higher than the Schelling points. Also means I have an odd number of self-mod events, which may be harder to guess. (One alternate strategy I considered was DC'ing even-self-modders, which could be done with a complex scaffold of thread messages... but it meant that odd-self-modders DC'd you and you'd need some sort of kill-switch when fighting true quines and nondeterministic-self-modders unless you wanted to throw too much to chance.)
             (else (if (eq? 'C ((eval opp-source-2) (eval (namespace-variable-value 'code #f #f namespace) namespace))) ;Well then Omega it is!
                       'C
                       maniacal-laugh))))))